import{s as te,n as ae,o as ne}from"../chunks/scheduler.9039eef2.js";import{S as ie,i as re,g as l,s as i,r as O,A as le,h as s,f as a,c as r,j as Z,x as _,u as I,k as q,l as ee,y as se,a as n,v as U,d as B,t as z,w as V}from"../chunks/index.ded8f90d.js";import{H as j}from"../chunks/Heading.f027f30d.js";function oe(G){let o,x,T,y,m,N='<img src="https://huggingface.co/datasets/trl-internal-testing/example-images/resolve/main/images/trl_banner_dark.png"/>',$,u,P,f,W=`TRL is a full stack library where we provide a set of tools to train transformer language models with Reinforcement Learning, from the Supervised Fine-tuning step (SFT), Reward Modeling step (RM) to the Proximal Policy Optimization (PPO) step.
The library is integrated with 🤗 <a href="https://github.com/huggingface/transformers" rel="nofollow">transformers</a>.`,M,g,J='<img src="https://huggingface.co/datasets/trl-internal-testing/example-images/resolve/main/images/TRL-readme.png"/>',k,p,K="Check the appropriate sections of the documentation depending on your needs:",H,h,R,c,Q='<li><a href="models">Model Classes</a>: <em>A brief overview of what each public model class does.</em></li> <li><a href="sft_trainer"><code>SFTTrainer</code></a>: <em>Supervise Fine-tune your model easily with <code>SFTTrainer</code></em></li> <li><a href="reward_trainer"><code>RewardTrainer</code></a>: <em>Train easily your reward model using <code>RewardTrainer</code>.</em></li> <li><a href="trainer"><code>PPOTrainer</code></a>: <em>Further fine-tune the supervised fine-tuned model using PPO algorithm</em></li> <li><a href="best-of-n">Best-of-N Sampling</a>: <em>Use best of n sampling as an alternative way to sample predictions from your active model</em></li> <li><a href="trainer"><code>DPOTrainer</code></a>: <em>Direct Preference Optimization training using <code>DPOTrainer</code>.</em></li> <li><a href="text_environment"><code>TextEnvironment</code></a>: <em>Text environment to train your model using tools with RL.</em></li>',F,b,S,v,X='<li><a href="sentiment_tuning">Sentiment Tuning</a>: <em>Fine tune your model to generate positive movie contents</em></li> <li><a href="lora_tuning_peft">Training with PEFT</a>: <em>Memory efficient RLHF training using adapters with PEFT</em></li> <li><a href="detoxifying_a_lm">Detoxifying LLMs</a>: <em>Detoxify your language model through RLHF</em></li> <li><a href="using_llama_models">StackLlama</a>: <em>End-to-end RLHF training of a Llama model on Stack exchange dataset</em></li> <li><a href="learning_tools">Learning with Tools</a>: <em>Walkthrough of using <code>TextEnvironments</code></em></li> <li><a href="multi_adapter_rl">Multi-Adapter Training</a>: <em>Use a single base model and multiple adapters for memory efficient end-to-end training</em></li>',C,w,D,d,Y='<div class="w-full flex flex-col space-y-4 md:space-y-0 md:grid md:grid-cols-2 md:gap-y-4 md:gap-x-5"><a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="https://huggingface.co/blog/rlhf"><img src="https://raw.githubusercontent.com/huggingface/blog/main/assets/120_rlhf/thumbnail.png" alt="thumbnail"/> <p class="text-gray-700">Illustrating Reinforcement Learning from Human Feedback</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="https://huggingface.co/blog/trl-peft"><img src="https://github.com/huggingface/blog/blob/main/assets/133_trl_peft/thumbnail.png?raw=true" alt="thumbnail"/> <p class="text-gray-700">Fine-tuning 20B LLMs with RLHF on a 24GB consumer GPU</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="https://huggingface.co/blog/stackllama"><img src="https://github.com/huggingface/blog/blob/main/assets/138_stackllama/thumbnail.png?raw=true" alt="thumbnail"/> <p class="text-gray-700">StackLLaMA: A hands-on guide to train LLaMA with RLHF</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="https://huggingface.co/blog/dpo-trl"><img src="https://github.com/huggingface/blog/blob/main/assets/157_dpo_trl/dpo_thumbnail.png?raw=true" alt="thumbnail"/> <p class="text-gray-700">Fine-tune Llama 2 with DPO</p></a> <a class="!no-underline border dark:border-gray-700 p-5 rounded-lg shadow hover:shadow-lg" href="https://huggingface.co/blog/trl-ddpo"><img src="https://github.com/huggingface/blog/blob/main/assets/166_trl_ddpo/thumbnail.png?raw=true" alt="thumbnail"/> <p class="text-gray-700">Finetune Stable Diffusion Models with DDPO via TRL</p></a></div>',E,L,A;return u=new j({props:{title:"TRL - Transformer Reinforcement Learning",local:"trl---transformer-reinforcement-learning",headingTag:"h1"}}),h=new j({props:{title:"API documentation",local:"api-documentation",headingTag:"h2"}}),b=new j({props:{title:"Examples",local:"examples",headingTag:"h2"}}),w=new j({props:{title:"Blog posts",local:"blog-posts",headingTag:"h2"}}),{c(){o=l("meta"),x=i(),T=l("p"),y=i(),m=l("div"),m.innerHTML=N,$=i(),O(u.$$.fragment),P=i(),f=l("p"),f.innerHTML=W,M=i(),g=l("div"),g.innerHTML=J,k=i(),p=l("p"),p.textContent=K,H=i(),O(h.$$.fragment),R=i(),c=l("ul"),c.innerHTML=Q,F=i(),O(b.$$.fragment),S=i(),v=l("ul"),v.innerHTML=X,C=i(),O(w.$$.fragment),D=i(),d=l("div"),d.innerHTML=Y,E=i(),L=l("p"),this.h()},l(e){const t=le("svelte-u9bgzb",document.head);o=s(t,"META",{name:!0,content:!0}),t.forEach(a),x=r(e),T=s(e,"P",{}),Z(T).forEach(a),y=r(e),m=s(e,"DIV",{style:!0,"data-svelte-h":!0}),_(m)!=="svelte-160pg0b"&&(m.innerHTML=N),$=r(e),I(u.$$.fragment,e),P=r(e),f=s(e,"P",{"data-svelte-h":!0}),_(f)!=="svelte-k9dkk3"&&(f.innerHTML=W),M=r(e),g=s(e,"DIV",{style:!0,"data-svelte-h":!0}),_(g)!=="svelte-dcmq8o"&&(g.innerHTML=J),k=r(e),p=s(e,"P",{"data-svelte-h":!0}),_(p)!=="svelte-113r82x"&&(p.textContent=K),H=r(e),I(h.$$.fragment,e),R=r(e),c=s(e,"UL",{"data-svelte-h":!0}),_(c)!=="svelte-wkd90b"&&(c.innerHTML=Q),F=r(e),I(b.$$.fragment,e),S=r(e),v=s(e,"UL",{"data-svelte-h":!0}),_(v)!=="svelte-a8fpa6"&&(v.innerHTML=X),C=r(e),I(w.$$.fragment,e),D=r(e),d=s(e,"DIV",{class:!0,"data-svelte-h":!0}),_(d)!=="svelte-8ufs3j"&&(d.innerHTML=Y),E=r(e),L=s(e,"P",{}),Z(L).forEach(a),this.h()},h(){q(o,"name","hf:doc:metadata"),q(o,"content",me),ee(m,"text-align","center"),ee(g,"text-align","center"),q(d,"class","mt-10")},m(e,t){se(document.head,o),n(e,x,t),n(e,T,t),n(e,y,t),n(e,m,t),n(e,$,t),U(u,e,t),n(e,P,t),n(e,f,t),n(e,M,t),n(e,g,t),n(e,k,t),n(e,p,t),n(e,H,t),U(h,e,t),n(e,R,t),n(e,c,t),n(e,F,t),U(b,e,t),n(e,S,t),n(e,v,t),n(e,C,t),U(w,e,t),n(e,D,t),n(e,d,t),n(e,E,t),n(e,L,t),A=!0},p:ae,i(e){A||(B(u.$$.fragment,e),B(h.$$.fragment,e),B(b.$$.fragment,e),B(w.$$.fragment,e),A=!0)},o(e){z(u.$$.fragment,e),z(h.$$.fragment,e),z(b.$$.fragment,e),z(w.$$.fragment,e),A=!1},d(e){e&&(a(x),a(T),a(y),a(m),a($),a(P),a(f),a(M),a(g),a(k),a(p),a(H),a(R),a(c),a(F),a(S),a(v),a(C),a(D),a(d),a(E),a(L)),a(o),V(u,e),V(h,e),V(b,e),V(w,e)}}}const me='{"title":"TRL - Transformer Reinforcement Learning","local":"trl---transformer-reinforcement-learning","sections":[{"title":"API documentation","local":"api-documentation","sections":[],"depth":2},{"title":"Examples","local":"examples","sections":[],"depth":2},{"title":"Blog posts","local":"blog-posts","sections":[],"depth":2}],"depth":1}';function ge(G){return ne(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class pe extends ie{constructor(o){super(),re(this,o,ge,oe,te,{})}}export{pe as component};
